package com.study.sketch.learning.activity;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.viewpager2.adapter.FragmentStateAdapter;
import androidx.viewpager2.widget.ViewPager2;

import com.google.android.material.tabs.TabLayout;
import com.study.sketch.learning.R;
import com.study.sketch.learning.databinding.ActivityMainBinding;
import com.study.sketch.learning.fragment.FragmentFavorite;
import com.study.sketch.learning.fragment.FragmentMain;
import com.study.sketch.learning.fragment.FragmentGallery;
import com.study.sketch.learning.manager.Common;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class ActivityMain extends AppCompatActivity {

    private ActivityMainBinding binding;

    private List<Fragment> listFragment = new ArrayList<>();


    private String[] permissions;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Common.setStatusBarTextColor(this, true);
        binding = ActivityMainBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
//        fragmentAlbum = FragmentAlbum.newInstance();
        listFragment.add(FragmentMain.newInstance());
        listFragment.add(FragmentGallery.newInstance());
        listFragment.add(FragmentFavorite.newInstance());

        onTabInit();
        binding.viewPager2.setUserInputEnabled(false);
        binding.viewPager2.setAdapter(new FragmentStateAdapter(this) {
            @NonNull
            @Override
            public Fragment createFragment(int position) {
                return listFragment.get(position);
            }

            @Override
            public int getItemCount() {
                return listFragment.size();
            }
        });
        bingTabVp();
    }
    private void bingTabVp() {
        binding.tab.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(true);
                binding.viewPager2.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(false);
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
        binding.viewPager2.registerOnPageChangeCallback(new ViewPager2.OnPageChangeCallback() {
            @Override
            public void onPageSelected(int position) {
                super.onPageSelected(position);
                Objects.requireNonNull(binding.tab.getTabAt(position)).select();
            }
        });
    }


    private void onTabInit() {

        for (int i = 0; i < listFragment.size(); i++) {
            TabLayout.Tab tab = binding.tab.newTab();
            View inflate = LayoutInflater.from(this).inflate(R.layout.customer_tab_view, null, false);
            ImageView icon = inflate.findViewById(R.id.im_icon);
            if (i == 0) {
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.status_tab_home));
            } else  if (i == 1){
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.status_gallery));
            }else {
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.status_tab_favorite));
            }
            tab.setCustomView(inflate);
            binding.tab.addTab(tab);
        }

    }


}